'Pollin mit DHT11, DHT21, DHT22, AM2303, RHT03
'Auto-Abschaltung (<1uA), Einschalten mit Reset
'
'bei Nichtgebrauch DHT schtzen, auch vor UV-Licht !!!
'
'Reinigung laut Datenblatt:
'Backofen bei 50-60 2 Stunden, RH<10%, dann
'5 Stunden bei 20-30 in ein feuchtes Tuch wickeln RH>70%
'-------------------------------------------------------------------------------
'B4-Vo wird fr DHT11-Pin2 freigemacht, indem R2 nicht bestckt wird
'und bei Vcc=4,5V R3=0R(56R) bestckt wird.
'Es kann auch ein anderer Port in Zeile 33 eingestellt werden.
'-------------------------------------------------------------------------------
'           ______ 2313 ______
'           1-Reset     Vcc-20            +4,5V
' TL1       2-D0/Rx  Sck/B7-19 scl        ***
' TL2       3-D1/Tx Miso/B6-18            ***
' RS(lcd4)  4-A1/X2 Mosi/B5-17 sda        ***
' E (lcd6)  5-A0/X1      B4-16 Vo(lcd3)   *** DHT11-Pin2+4k7
' Ti0       6-D2/Int0 OC/B3-15 d7(lcd10)
' TL3       7-D3/Int1 OC/B2-14 d6(lcd9)
' TL4       8-D4/T0 Ain1/B1-13 d5(lcd8)
' Buzz      9-D5/T1 Ain0/B0-12 d4(lcd7)
' DHT-Pin4  10-Gnd       D6-11 Vdd(lcd2)  *** DHT11-Pin1+4k7
'-------------------------------------------------------------------------------
'$PROG &HFF,&HE4,&HDF,&HFF '=Fuse
$regfile = "attiny2313.dat"
$crystal = 8000000
$hwstack = 32
$swstack = 32
$framesize = 32

Dhtout Alias Portb.4 : Dhtin Alias Pinb.4 : Dhtddr Alias Ddrb.4       'DHT11
Lcdddr Alias Ddrd.6 : Lcdout Alias Portd.6     'Lcd

Set Lcdddr : Set Lcdout                        'Lcd+DHT-Speisung
Set Dhtddr : Set Dhtout                        'Kontrolle an Master

Config Lcdpin = Pin , Db4 = Portb.0 , Db5 = Portb.1 , Db6 = Portb.2 , Db7 = Portb.3 , E = Porta.0 , Rs = Porta.1
Initlcd : Cursor Off : Lcd " DHT11- " : Locate 2 , 1 : Lcd "Familie "

Declare Sub Hol_ht
Dim A As Long                                  'absolut Wasser in mg/m^3
Dim B As Long
Dim T As Byte                                  'Temperatur
Dim H As Byte                                  'rel. Feuchte
Dim Pwrdwn As Byte                             'Zhler
Dim 8bit As Byte , 5byte(5) As Byte
Dim I As Byte , J As Byte                      'Index
'-------------------------------------------------------------------------------
Do
   Wait 2                                      'warte bis Power stabil
   Hol_ht                                      'Sub
   Cls : Lcd T ; "C " ; H ; "%"                'zeig
'Absolut
   Restore Dta0 : For I = 0 To T : Read A : Next I
   A = A * H : A = A / 100
   Locate 2 , 1 : Lcd ; A ; " mg    "
'Taupunkt
   Restore Dta0 : J = 0 : B = 0
   While B < A : Read B : J = J + 1 : Wend : J = J -2
   Wait 2 : Cls : Lcd "Taupunkt" : Locate 2 , 1 : Lcd J ; "C      "
'Stromsparen
   Pwrdwn = Pwrdwn + 1
Loop Until Pwrdwn = 99
Porta = 0 : Portb = 0 : Portd = 0              'alles aus
Power Powerdown                                '<1uA
'-------------------------------------------------------------------------------
Sub Hol_ht
   Set Dhtddr : Reset Dhtout : Waitms 25       'bertragung einleiten 0
   Set Dhtout : Waitus 40                      'bertragung einleiten 1
   Reset Dhtddr                                'Kontrolle an DHT bergeben
   Waitus 40 : If Dhtin = 1 Then Exit Sub      'if 1 fehler
   Waitus 80 : If Dhtin = 0 Then Exit Sub      'if 0 fehler
   While Dhtin = 1 : Wend                      'warte auf 0
   For J = 1 To 5                              '5Byte
    For I = 1 To 8                             '8bit abholen
      Shift 8bit , Left                        '*2
      While Dhtin = 0 : Wend                   'warte auf 1
      Waitus 47                                'krzer oder lnger als 50us ?
      8bit = 8bit Or Dhtin
      While Dhtin = 1 : Wend                   'warte auf 0
    Next I
    5byte(j) = 8bit
   Next J
   Set Dhtddr : Set Dhtout                     'Kontrolle an Master zurck
   H = 5byte(1) : T = 5byte(3)
End Sub
End
Dta0:

Data 4846& , 5192& , 5558& , 5947& , 6460& , 6797& , 7260& , 7750& , 8269& , 8818&       '0-9C
Data 9390& , 10012& , 10660& , 11344& , 12065& , 12826& , 13628& , 14473& , 15363& , 16300&       '10-19C
Data 17286& , 18323& , 19413& , 20559& , 21762& , 23025& , 24351& , 25742& , 27201& , 28730&       '20-29C
Data 30332& , 32010& , 33767& , 35606& , 37530& , 39542& , 41646& , 43844& , 46140& , 48538&       '30-39C
Data 51041& , 53654& , 56379& , 59221& , 62183& , 65271& , 68487& , 71837& , 75324& , 78954&       '40-49C
Data 82730&                                    '50C

'End